<template>
  <meter-slider
    v-if="options.length"
    v-model="selfValue"
    :min="0"
    :max="options.length - 1"
    :step="1"
    :unit="labelWidth"
    :format="val => options[val][label]"
    class="simple"
  />
</template>

<script>
import MeterSlider from '../helper/MeterSlider'
export default {
  name: 'HorizontalSelect',
  components: { MeterSlider },
  props: {
    value: { type: [String, Number], default: '' },
    options: { type: Array, default: () => [] },
    prop: { type: String, default: 'id' },
    label: { type: String, default: 'title' },
    labelWidth: { type: Number, default: 130 }
  },
  data() {
    return {
      selfValue: 0
    }
  },
  watch: {
    value: {
      handler(val) {
        for (let i = 0, ii = this.options.length; i < ii; i++) {
          if (this.options[i][this.prop] === val) {
            this.selfValue = i
            return
          }
        }
        this.selfValue = 0
      },
      immediate: true
    },
    selfValue(val) {
      let id = this.options[val][this.prop]
      if (id !== this.value) this.$emit('input', id)
    }
  }
}
</script>
